<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <title>Frontend Guidlines</title>
    <style type="text/css">
    @import url(http://fonts.googleapis.com/css?family=Open+Sans:400,700);
    body {
        display: block;
        margin: 40px auto;
        max-width: 650px;
        line-height: 1.6;
        font-size: 18px;
        color: #444;
        padding: 0 10px;
        font-family: 'Open Sans', sans-serif;
    }
    h1,h2,h3 {
        line-height:1.2;
    }
    input, textarea {
        line-height: 1.6;
        font-size: 18px;
        color: #444;
    }
    li > ol {
        list-style-type: upper-roman;
    }
    code {
        background: #f1f1f1;
        padding: 5px;
        font-size: 16px;
    }
    .syntaxhighlighter {
        position: relative;
        overflow: auto;
        white-space: nowrap;
        font-size: 16px;
        background: #f1f1f1;
        padding: 5px 10px;
    }
    .syntaxhighlighter code {
        padding: 0;
    }
    .syntaxhighlighter textarea {
        resize: none;
        box-sizing: border-box;
        position: absolute;
        font-size: 16px;
        left: 0;
        top: 0;
        width: 100%;
        height: 100%;
        border: none;
        background: white;
        padding-left: 1em;
        overflow: hidden;
        white-space: pre;
    }
    .toolbar {
        display: none;
    }
    .bad {
        border-left: solid 0.5rem #e74c3c;
    }
    .good {
        border-left: solid 0.5rem #2ecc71;
    }
    .example {
        border-left: solid 0.5rem #34495e;
    }
    .menu {
        position: fixed;
        right: 0;
        top: 0;
        background: #f1f1f1;
        padding: 5px 10px;
        font-weight: bold;
    }
    </style>

</head>
<body>

    <div class="menu"><a href="#menu">Menu</a></div>

    <h1>Frontend Guidelines</h1>

    <h3>Contents</h3>

    <ol id="menu">
        <li><a href="#css">CSS</a>
            <ol>
                <li><a href="#css-principles">General CSS Principles</a></li>
                <li><a href="#css-syntax">Syntax and formatting</a></li>
                <li><a href="#css-indenting">Indenting</a></li>
                <li><a href="#css-typography">Typography</a></li>
                <li><a href="#css-comments">Comments</a></li>
                <li><a href="#css-specificity">Specificity</a></li>
                <li><a href="#css-important">!important</a></li>
            </ol>
        </li>
        <li><a href="#less">Less</a>
            <ol>
                <li><a href="#less-principles">General Less Principles</a></li>
                <li><a href="#less-nesting">Nesting</a></li>
                <li><a href="#less-variables">Variables</a></li>
                <li><a href="#less-hooks">Hooks</a></li>
            </ol>
        </li>
        <li><a href="#V10">V10</a>
            <ol>
                <li><a href="#V10-icons">Icons</a></li>
                <li><a href="#V10-mixins">Mixins</a></li>
            </ol>
        </li>
    </ol>

    <hr id="css"/>
    <h2>CSS</h2>

    <div id="css-principles"></div>
    <h3>General CSS Principles <small>(juniors+)</small></h3>

    <ul>
        <li>Every time you write inline styles in your markup, a front-end developer somewhere dies - whether it's in a style tag or directly in the markup. Don't do it.</li>
        <li>Add CSS through external files, minimizing the number of files, if possible. CSS should always be included in the <code>&lt;head&gt;</code> of the document.</li>
        <li>Use the <code>&lt;link&gt;</code> tag to include, never @import.</li>
        <li>Ensure markup and style stays separate (some style classes are allowed, e.g imageReplace etc). Only use style only markup if you absolutely have to (e.g extra wrapping elements); consider :before and :after CSS pseudo-elements if styles are not 100% necessary.</li>
    </ul>

    <div id="css-syntax"></div>
    <h3>Syntax and formatting <small>(juniors+)</small></h3>

    <ul>
        <li>Use multi-line CSS declarations. This helps with version control (diff-ing single line CSS can be a nightmare). Group CSS declarations by type - keeping font related styling together, layout styling together etc - and ordered by relevance, not alphabetized.</li>
        <li>All CSS rules should have a space after the selector colon and a trailing semi-colon.</li>
        <li>Use shorthand when specifying multiple values. Remember longhand can be shorter for single values.</li>
        <li>Multi-attribute selectors should go on separate lines.</li>
        <li>Don't over qualify class or ID selectors. Leads to specificity issues further down the line.</li>
    </ul>

    <div class="bad">
        <pre class="brush: css">
            // Bad
            div.content {}
        </pre>
    </div>

    <div class="good">
        <pre class="good brush: css">
            // Good
            .content {}
        </pre>
    </div>

    <ul>
        <li>0 requires no units</li>
    </ul>

    <div class="good">
        <pre class="good brush: css">
            // Good
            .bar,
            .foo[href="bar"] {
                position: absolute;
                top: 0;
                right: 0;
                bottom: 0;
                left: 0;

                padding: 10px 0 0 0;
                margin: 10px 0;

                background: red;
                border-radius: 10px;
                -moz-border-radius: 10px;
            }
        </pre>
    </div>

    <div id="css-indenting"></div>
    <h3>Indenting <small>(juniors+)</small></h3>

    <p>For each level of markup nesting, indent your CSS to match. For example:</p>

    <div class="good">
        <pre class="good brush: css">
            // Good
            nav {}
                nav li {}
                    nav li a {}

            .content {}
                .content p {}
        </pre>
    </div>

    <div id="css-typography"></div>
    <h3>Typography <small>(juniors+)</small></h3>

    <p>@font-face should be used for font replacement where possible - ensuring that the font can be safely used in .ttf format on the web in agreement with its licensing agreement.  Where this is an issue, look to use tools such as <a href="https://typekit.com/">TypeKit</a> or <a href="http://fontdeck.com/">Fontdeck</a></p>
    <p>To generate @font-face files, the <a href="http://www.fontsquirrel.com/fontface/generator">Font Squirrel font-face generator</a> should be used.</p>
    <p>Always define <a href="http://csswizardry.com/2012/02/pragmatic-practical-font-sizing-in-css/">supporting font-size classes</a>, in conjunction with headers to avoid restyling header sizes.</p>

    <div id="css-comments"></div>
    <h3>Comments <small>(juniors+)</small></h3>
    <p>Comment as much as you can as often as you can. Where it might be useful, include a commented out piece of markup which can help put the current CSS into context.</p>
    <p>CSS will be minified before it hits live servers, so don't worry about excessive commenting bloating code - the benefits far outweigh any file-size worries.</p>
    <p>This is especially true for responsive layouts where percentage width/margin's have been worked out.  Always comment in the ratio so that the resulting % values mean something to the next developer viewing your CSS.  A random 6dp percentage will mean nothing to anyone else looking at your code.</p>
    <p>Brak your comments down do not put one long string of text as this is hard to read quickly</p>

    <p>Single Comment</p>
    <div class="example">
        <pre class="good brush: css">
            .button {
                vertical-align: top;
                color: #ffffff;
                // Height used as padding is un-reliable
                height: @button-height;
                .font-size(15px);
                .gradient(@start-color, @end-color);
                .inline-block;
                .hook-button;  

                &:hover {
                    background #000;
                }
             
            }
             
            .active {
                // Leaving space above
            }
        </pre>
    </div> 
    <p>Multi Comments</p>
    <div class="example">
        <pre class="good brush: css">
            /*
             * 1. Required for `a` elements
             * 2. Required for `button` and `input` elements
             * 3. `line-height` is used to create a height
             * 4. `height` is neccesary for `input` elments in Firefox and Opera because `line-height` is not working.
             * 5. Reset button group whitespace hack
             * 6. Style
             * 7. IE7 Love
            */
             
            .btn {
                /* 1 */
                text-decoration: none;
                /* 2 */
                border: @button-border;
                margin-bottom: 0;
                /* 3 */
                line-height: @button-line-height;
                /* 4 */
                height: @button-height;
                /* 5 */
                .font-size(@button-font-size);
                /* 6 */
                vertical-align: middle;
                cursor: pointer;
                margin: @button-margin;
                background-color: @button-background;
                color: @button-color;
                padding: @button-padding;
                font-family: @button-font-family;
                .transition(all .1s ease-in-out);
                /* 7 */
                .inline-block();
                .hook-button;
            }
        </pre>
    </div>     

    <div id="css-specificity"></div>
    <h3>Specificity, IDs and classes <small>(juniors+)</small></h3>
    <p>CSS is designed to cascade, so make sure you understand <a href="http://www.stuffandnonsense.co.uk/archives/css_specificity_wars.html">cascading and selector specificity</a>.  It will enable you to write very terse and effective code.</p>
    <p>Use of IDs and classes effect specificity massively.  Only use IDs where deemed necessary, especially on larger builds.  Classes are much more modular and portable.  If you want to use an ID solely as a JavaScript hook, consider using the ID alongside a class for CSS styling.</p>

    <div id="css-important"></div>
    <h3>!important <small>(juniors+)</small></h3>
    <p>Using <code>!important</code> reactively, e.g. to get yourself out of nasty specificity situations, is not advised. Rework your CSS and try to combat these issues by refactoring your selectors. Keeping selectors short and avoiding IDs will help you out here massively.</p>

    <h3>Magic numbers and absolutes <small>(juniors+)</small></h3>
    <p>A magic number is a number which is used because ‘it just works’. These are bad because they rarely work for any real reason and are not usually very futureproof or flexible/forgiving. They tend to fix symptoms and not problems.</p>
    <p>For example, using .dropdown-nav li:hover ul { top: 37px; } to move a dropdown to the bottom of the nav on hover is bad, as 37px is a magic number. 37px only works here because in this particular scenario the .dropdown-nav happens to be 37px tall.</p>
    <p>Instead you should use .dropdown-nav li:hover ul { top: 100%; } which means no matter how tall the .dropdown-nav gets, the dropdown will always sit 100% from the top.</p>
    <p>Every time you hard code a number think twice; if you can avoid it by using keywords or ‘aliases’ (i.e. top: 100% to mean ‘all the way from the top’) or—even better—no measurements at all then you probably should.</p>
    <p>Every hard-coded measurement you set is a commitment you might not necessarily want to keep.</p>

    <h3>Images <small>(juniors+)</small></h3>
    <p>Image names should use dashes and be named so that their use is clear i.e. icon-facebook-blue.png</p>

    <h3>Debugging <small>(juniors+)</small></h3>
    <p>If you run into a CSS problem, take code away before you start adding more in a bid to fix it. The problem will exist in the CSS that is already written, more CSS isn't necessarily the right answer!</p>
    <p>It can be tempting to put overflow:hidden; on something to hide the effects of a layout quirk, but overflow was probably never the problem; fix the problem, not its symptoms.</p>

    <h3>OOCSS <small>(seniors+)</small></h3>

    <p>When building components, or modules, try and keep a DRY, OO frame of mind.</p>
    <p>Instead of building dozens of unique components, try and spot repeated design patterns and abstract them; build these skeletons as base 'objects' and then peg classes onto these to extend their styling for more unique circumstances.</p>
    <p>If you have to build a new component split it into structure and skin; build the structure of the component using very generic classes so that we can reuse that construct and then use more specific classes to skin it up and add design treatments.</p>
    <p>Read:</p>
    <ul>
        <li><a href="http://csswizardry.com/2011/09/the-nav-abstraction/" target="_blank">The Nav Abstraction</a></li>
    </ul>

    <hr id="less"/>
    <h2>Less</h2>

    <div id="less-principles"></div>
    <h3>General Less Principles <small>(juniors+)</small></h3>
    <ul>
        <li>Be sure to know the ins-and-outs of excellent vanilla CSS and where a preprocessor can aid that, not hinder or undo it. Learn the downsides of preprocessors inside-out and then fuse the best aspects of the two with the bad bits of neither.</li>
        <li>One of the most powerful features of using a preprocessor is simply being able to separate your CSS into a number of different files that are pulled in and combined at compile time. This makes it easier to make your code more maintainable and better structured than having all of your code in one file.</li>
    </ul>

    <div id="less-nesting"></div>
    <h3>Nesting <small>(juniors+)</small></h3>
    <p>When nesting selectors, try not to nest more than 3 levels deep. If you find yourself writing deeply nested selectors, it is usually a sign that you should rethink how you have structured your markup or class declarations.</p>
    <p>Nest only when it would actually be necessary in vanilla CSS, e.g.</p>

    <div class="example">
        <pre class="good brush: css">
            .header {}
            .header .site-nav {}
            .header .site-nav li {}
            .header .site-nav li a {}
        </pre>
    </div>

    <p>Would be wholly unnecessary in normal CSS, so the following would be bad Less:</p>

    <div class="bad">
        <pre class="good brush: css">
            .header {
                .site-nav {
                    li {
                        a {}
                    }
                }
            }
        </pre>
    </div>

    <p>If you were to write this in Less, it would look more like:</p>

    <div class="good">
        <pre class="good brush: css">
            .header {}

            .site-nav {

                li {}

                a {}

            }
        </pre>
    </div>

    <p>Let your nesting breath so it is easier too scan read, this also leaves more room for comments. This can be extremely helpful with lots of CSS in a file.</p>

    <div class="bad">
        <pre class="good brush: css">
            .header {}
            .site-nav {
                li {}
                a {}
            }
        </pre>
    </div>

    <div class="good">
        <pre class="good brush: css">
            .header {}

            .site-nav {

                li {}

                a {}

            }
        </pre>
    </div>

    <div id="less-variables"></div>
    <h3>Variables <small>(juniors+)</small></h3>
    <ul>
        <li>Use variables first and foremost if a variable is available to change a CSS attr then use it.</li>
        <li>DO NOT go overkill on your variables use only as needed and create your own ones for your projects as needed if you create too many this can become very hard to scale and for someone else to pick up the project.</li>
        <li>Variables should use the follwing syntax @section__element--property_modifier</li>
    </ul>

    <div id="less-hooks"></div>
    <h3>Hooks <small>(juniors+)</small></h3>
    <p>To prevent overhead selectors, we use Mixins from LESS, which hook into predefined selectors from the UIkit source and apply additional properties. Selectors don't have to be repeated throughout all documents and gobal changes can be made much easier.</p>
    <p>Hooks should be used after variables so we are not creating extra selectors.</p>

    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/2.1.3/jquery.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/SyntaxHighlighter/3.0.83/scripts/shCore.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/SyntaxHighlighter/3.0.83/scripts/shBrushCss.min.js"></script>
    <script>
        SyntaxHighlighter.defaults['gutter'] = false;
        SyntaxHighlighter.defaults['smart-tabs'] = false;
        SyntaxHighlighter.all()

        $(function() {
            $.fn.SmoothAnchors = function() {

                function scrollBodyTo(destination, hash) {

                    // Change the hash first, then do the scrolling. This retains the standard functionality of the back/forward buttons.
                    var scrollmem = $(document).scrollTop();
                    window.location.hash = hash;
                    $(document).scrollTop(scrollmem);
                    $("html,body").animate({
                        scrollTop: destination
                    }, 400);

                }

                if (typeof $().on == "function") {
                    $(document).on('click', 'a[href^="#"]', function() {

                        var href = $(this).attr("href");

                        if ($(href).length == 0) {

                            var nameSelector = "[name=" + href.replace("#", "") + "]";

                            if (href == "#") {
                                scrollBodyTo(0, href);
                            }
                            else if ($(nameSelector).length != 0) {
                                scrollBodyTo($(nameSelector).offset().top, href);
                            }
                            else {
                                // fine, we'll just follow the original link. gosh.
                                window.location = href;
                            }
                        }
                        else {
                            scrollBodyTo($(href).offset().top, href);
                        }
                        return false;
                    });
                }
                else {
                    $('a[href^="#"]').click(function() {
                        var href = $(this).attr("href");

                        if ($(href).length == 0) {

                            var nameSelector = "[name=" + href.replace("#", "") + "]";

                            if (href == "#") {
                                scrollBodyTo(0, href);
                            }
                            else if ($(nameSelector).length != 0) {
                                scrollBodyTo($(nameSelector).offset().top, href);
                            }
                            else {
                                // fine, we'll just follow the original link. gosh.
                                window.location = href;
                            }
                        }
                        else {
                            scrollBodyTo($(href).offset().top, href);
                        }
                        return false;
                    });
                }
            };
        });

        $(document).ready(function() {
            $().SmoothAnchors();
        });

    </script>

</body>
</html>